/*
University of Sao Paulo - Institute of Mathematics and Computer Science ( ICMC - USP )
Computer Graphics - SCC 0250
Developer (PAE): Vinicius R. P. Borges
Profa: Maria Cristina Ferreira de Oliveira

Codigo 2 - Aula de Laboratorio 1 - 31/08/2012
CODE 2 - Lab 1

> Para compilar este codigo, execute no terminal do Linux - To compile this code, type the following command on Linux Terminal

# gcc translacao.c  -lX11 -lglut -lGL -lGLU -lm -o translacao

Para executar o codigo, digite - To run this code, type:

# ./translacao
*/

// Biblioteca entrada e saida
#include <stdio.h>

// Biblioteca com aplicacoes da GLUT
#include <GL/glut.h>

// Biblioteca que implementa rotinas do OpenGL na GLUT
#include <GL/glu.h>

// Biblioteca OpenGL
#include <GL/gl.h>

// Identificador da janela GLUT
int window;

// Flag que controla a operacao: translacao, rotacao ou escala
int flag = 0;

// Variaveis que controlam o fator de deslocamento
GLfloat fatorDx = 0.2f;
GLfloat fatorDy = 0.2f;

void DrawGLScene()
{
     // Limpa o buffer
     glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
     
     // Desenha objetos com a cor vermelha
     glColor3f(1.0f,0.0f,0.0f);
     
     // Desenha um quadrado
     glBegin(GL_POLYGON);
            glVertex2i(20,20);
            glVertex2i(20,40);
            glVertex2i(40,40);
            glVertex2i(40,20);
     glEnd();
     
     // Processa as  rotinas do OpenGL o mais rapido possivel
     glFlush();
}

// Funcao que trata eventos do teclado
void keyPressed(unsigned char key, int x, int y){
     
     // Se usuario pressiona ESC, programa eh encerrado
     if(key == 'z'){
            // Libera espaco da memoria ocupado pela janela
            glutDestroyWindow(window);
            
            // Encerra aplicacao
            exit (0);
     }
     
     // Translacao
     if(key == 't'){
            flag = 1;
     }
}

// Funcao que faz a translacao
void translate2D(GLfloat dx, GLfloat dy)
{
     //Carrega a matriz de modelo
     glMatrixMode(GL_MODELVIEW);
     
     // Translacao 2D
     glTranslatef(dx,dy,0.0f);
}

// Funcao que trata teclas especiais do teclado
void keyPressed_special(int key, int x, int y){
     
     // Setas soh fazem efeito se algumas das teclas normais especificadas funcionaram
     if(flag == 1)
     {
            if(key == GLUT_KEY_RIGHT){
                // trata tecla direita do teclado
                translate2D(fatorDx,0.0f);
             }
     
            if(key == GLUT_KEY_LEFT){
                // trata tecla esquerda do teclado
                translate2D(- fatorDx,0.0f);
            }
     
            if(key == GLUT_KEY_UP){
                // trata tecla - para cima - do teclado
                translate2D(0.0f,fatorDy);
            }
            
            if(key == GLUT_KEY_DOWN){
                // trata tecla - para baixo - do teclado
                translate2D(0.0f, - fatorDy);
            } 
     }
     
     // Redesenha a cena grafica na tela
     glutDisplayFunc(DrawGLScene);
     
     // Atualiza a cena na janela
     glutPostRedisplay();   
}

// Inicia as configuracoes da tela de projecao
void InitGL(int largura, int altura)
{
     
     // Ajusta a cor de fundo para branco
     glClearColor(1.0f,1.0f,1.0f,0.0f);
     
     // Carrega a matriz de projecao
     glMatrixMode(GL_PROJECTION);
     
     // Projecao ortogonal que mapeia  objetos da coordenada
     // do mundo para coordenadas da tela
     gluOrtho2D(0.0,100.0,0.0,100.0);
}

//Funcao principal do programa
main(int argc, char *argv[])
{
      // Inicializacao da glut
      glutInit(&argc,argv);
      
      // Ajuste de display para o usuario
      glutInitDisplayMode(GLUT_SINGLE | GLUT_RGBA);
      
      // Posicao inicial da janela na tela
      glutInitWindowPosition(0,0);
      
      // Ajusta as dimensoes da janela
      glutInitWindowSize(640,480);
      
      // Criacao da janela
      window = glutCreateWindow("Simple OpenGL Example");
      
      // Funcao que trata eventos do teclado
      glutKeyboardFunc(&keyPressed);
      
      // Funcao que trata teclas especiais do teclado
      glutSpecialFunc(&keyPressed_special);
      
      // Preparacao da cena grafica para desenhos utilizando primitivas
      InitGL(640,480);
      
      // Desenha a cena grafica na tela
      glutDisplayFunc(DrawGLScene);
      
      // Coloca programa em Loop Infinito
      glutMainLoop();
      
      return 0;
      
}

